local L = AceLibrary("AceLocale-2.2"):new("TrainerFu-MapNotes")

local gratuity = AceLibrary("Gratuity-2.0")
local Tablet = AceLibrary("Tablet-2.0")

L:RegisterTranslations("enUS", function() return {
	["MapNotes"] = true,
	["MapNote options. (Requires Cartographer)"] = true,
	["Enable trainer mapnotes"] = true,
	["Add a mapnote to show where your trainers are."] = true,
	["Filter"] = true,
	["Filter out trainers"] = true,
	["Select all"] = true,
	["Select none"] = true,
	

	["Alchemist"] = true,
	["Blacksmith"] = true,
	["Poison"] = true,
	["Cooking"] = true,
	["Misc"] = true,
	["Demon"] = true,
	["Druid"] = true,
	["Enchanter"] = true,
	["Engineer"] = true,
	["First Aid"] = true,
	["Fishing"] = true,
	["Herbalism"] = true,
	["Hunter"] = true,
	["Jewelcrafter"] = true,
	["Leatherworker"] = true,
	["Mage"] = true,
	["Mining"] = true,
	["Paladin"] = true,
	["Pet"] = true,
	["Priest"] = true,
	["Rogue"] = true,
	["Shaman"] = true,
	["Skinning"] = true,
	["Tailor"] = true,
	["Warlock"] = true,
	["Warrior"] = true,
	
	["Trainer"] = true,
	["Journeyman"] = true,
	["Expert"] = true,
	["Artisan"] = true,
	["Master"] = true,
} end)

TrainerFu_TrainerNotes = TrainerFu:NewModule("MapNotes", "AceEvent-2.0")

TrainerFu_TrainerNotes.icon = {
	["Alchemist"] = {
        text = L["Alchemist"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Alchemy",
    },
    ["Blacksmith"] = {
        text = L["Blacksmith"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Blacksmithing",
    },
	["Poison"] = {
        text = L["Poison"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Poison",
    },
	["Cooking"] = {
        text = L["Cooking"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Cooking",
    },
    ["Misc"] = {
        text = L["Misc"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Misc",
    },
    ["Demon"] = {
        text = L["Demon"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Demon",
    },
	["Druid"] = {
        text = L["Druid"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Druid",
    },
	["Enchanter"] = {
        text = L["Enchanter"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Enchanting",
    },
	["Engineer"] = {
        text = L["Engineer"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Engineering",
    },
	["First Aid"] = {
        text = L["First Aid"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Firstaid",
    },
	["Fishing"] = {
        text = L["Fishing"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Fishing",
    },
	["Herbalism"] = {
        text = L["Herbalism"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Herbalism",
    },
	["Hunter"] = {
        text = L["Hunter"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Hunter",
    },
	["Jewelcrafter"] = {
        text = L["Jewelcrafter"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Jewelcrafting",
    },
	["Leatherworker"] = {
        text = L["Leatherworker"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Leatherworking",
    },
	["Mage"] = {
        text = L["Mage"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Mage",
    },
	["Mining"] = {
        text = L["Mining"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Mining",
    },
	["Paladin"] = {
        text = L["Paladin"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Paladin",
    },
	["Pet"] = {
        text = L["Pet"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Pet",
    },
	["Priest"] = {
        text = L["Priest"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Priest",
    },
	["Rogue"] = {
        text = L["Rogue"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Rogue",
    },
	["Shaman"] = {
        text = L["Shaman"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Shaman",
    },
	["Skinning"] = {
        text = L["Skinning"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Skinning",
    },
	["Tailor"] = {
        text = L["Tailor"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Tailoring",
    },
	["Warlock"] = {
        text = L["Warlock"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Warlock",
    },
	["Warrior"] = {
        text = L["Warrior"],
        path = "Interface\\AddOns\\FuBar_TrainerFu\\icons\\Warrior",
    },
}

function TrainerFu_TrainerNotes:UpdateIconSize()
	for _,icon in pairs(self.icon) do
		icon.width = self.db.profile.iconSize
		icon.height = self.db.profile.iconSize
	end
end

function TrainerFu_TrainerNotes:OnInitialize()
	self.db = TrainerFu:AcquireDBNamespace("MapNotes")
    TrainerFu:RegisterDefaults("MapNotes", "account", {
		TrainerNotes = {}
    })
	TrainerFu:RegisterDefaults("MapNotes", "profile", {
		filter = {
			['*'] = true,
		},
		iconSize = 14
	})
	
	self:UpdateIconSize()
	
	filter = {
		name = L["Filter"],
		desc = L["Filter out trainers"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingTrainer(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingTrainer(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}
	for k,v in pairs(self.icon) do
		local k = k
		filter.args[string.gsub(k, "%s", "-")] = {
			name = v.text,
			desc = v.text,
			type = 'toggle',
			get = function()
				return self:IsShowingTrainer(k)
			end,
			set = function(value)
				return self:ToggleShowingTrainer(k, value)
			end,
		}
	end
	
	TrainerFu.OnMenuRequest.args.MapNotes = {
		type = 'group',
		name = L["MapNotes"],
		desc = L["MapNote options. (Requires Cartographer)"],
		disabled = function() return not Cartographer_Notes end,
		args = {
			filter = filter,
			addmapnote = {
				type = 'toggle',
				name = L["Enable trainer mapnotes"],
				desc = L["Add a mapnote to show where your trainers are."],
				get = function() return TrainerFu:IsModuleActive(self) end,
				set = function() TrainerFu:ToggleModuleActive(self) end,
			},
			iconsize = {
				type = 'range',
				name = "Icon size",
				desc = "Size of TrainerFu icons",
				get = function() return self.db.profile.iconSize end,
				set = function(size) 
					self.db.profile.iconSize = size 
					self:UpdateIconSize()
					Cartographer_Notes:RefreshMap()
				end,
				min = 6,
				max = 24,
				step = 1,
			}
		}
	}
end

function TrainerFu_TrainerNotes:OnEnable()
	if Cartographer_Notes then
        if not self.iconsregistered then
			for k,v in pairs(self.icon) do
                Cartographer_Notes:RegisterIcon(k, v)
            end
            self.iconsregistered = true
        end

        Cartographer_Notes:RegisterNotesDatabase("TrainerFu", self.db.account.TrainerNotes, self)
		
		self:RegisterEvent("GOSSIP_SHOW", "AddTrainerMapNote")
		self:RegisterEvent("TRAINER_SHOW", "AddTrainerMapNote")
    else
        TrainerFu:ToggleModuleActive(self, false)
    end
end

function TrainerFu_TrainerNotes:OnDisable()
    self:UnregisterAllEvents()

    if Cartographer_Notes then
        Cartographer_Notes:UnregisterNotesDatabase("TrainerFu")
    end
end

function TrainerFu_TrainerNotes:AddTrainerMapNote()
	trainer = TrainerFu_Trainer:GetTrainerInfo()

	--Talking to a trainer?
	local matches = { L["Trainer"], L["Journeyman"], L["Expert"], L["Artisan"], L["Master"] }
	local trainerFound = false
	for _,match in ipairs(matches) do
		if string.match(trainer.type, match) then
			trainerFound = true
		end
	end	
	
	if trainerFound then
		--Remove old trainernot if found
		for zone, x, y, _, _, data in Cartographer_Notes:IterateNearbyNotes(trainer.location, trainer.xcoord, trainer.ycoord, 10, "TrainerFu", 10, true) do
			if data.info == trainer.name then
				Cartographer_Notes:DeleteNote(zone, x, y)
			end
		end
	
		--Class trainer
		local _,_,iconName = string.find(trainer.type, "([%a%s]+)%sTrainer")
		--Profession trainer
		if not iconName then
			_,_,iconName = string.find(trainer.type, "[%a%s]+%s([%a%s]+)")
		end
		--If there is no icon for trainer show misc icon
		if not iconName or not self.icon[iconName] then
			--iconName = "Misc"
			return
		end
		
		Cartographer_Notes:SetNote(
			trainer.location, trainer.xcoord, trainer.ycoord, L:GetReverseTranslation(iconName), "TrainerFu",
			'title',  trainer.type,
			'titleR', 0,
			'titleG', 1,
			'titleB', 0,
			'info', trainer.name,
			'infoR', 1,
			'infoG', 1,
			'infoB', 1
		)
	end
end

function TrainerFu_TrainerNotes:IsNoteHidden(zone, id)
	return not self.db.profile.filter[self.db.account.TrainerNotes[zone][id].icon]
end

function TrainerFu_TrainerNotes:IsShowingTrainer(trainer)
	return self.db.profile.filter[trainer]
end

function TrainerFu_TrainerNotes:ToggleShowingTrainer(trainer, value)
	if value == nil then
		value = not self.db.profile.filter[trainer]
	end
	self.db.profile.filter[trainer] = value
	
	Cartographer_Notes:RefreshMap()
end
